#pragma once

#include "Defs.h"

enum PARSE_STATES{ PARSE_BEGIN, PARSE_S1, PARSE_S2, PARSE_S3, PARSE_S4, PARSE_S5, PARSE_S6,
					PARSE_S7, PARSE_S8, PARSE_S9, PARSE_S10, PARSE_S11, PARSE_S12, PARSE_S13, PARSE_S14,
					PARSE_S15, PARSE_S16, PARSE_S17, PARSE_S18, PARSE_S19, PARSE_S20, PARSE_S21, PARSE_S22,
					PARSE_S23, PARSE_ACCEPT};

enum REDUCTIONS{ RED_1, RED_2, RED_3, RED_4, RED_5, RED_6, RED_7, RED_8,
				RED_9, RED_10, RED_11, RED_12, RED_13, RED_14};

//							CUR. STATE,		INPUT,			REDUCE?		RULE,
const int PARSE_RULE[] = {	PARSE_BEGIN,	T_IDENTIFIER,	false,		PARSE_S1,
							PARSE_BEGIN,	'E',			false,		PARSE_S2,
							PARSE_BEGIN,	'T',			false,		PARSE_S3,
							PARSE_BEGIN,	'F',			false,		PARSE_S4,
							PARSE_BEGIN,	T_MIN,			false,		PARSE_S5,
							PARSE_BEGIN,	T_ADD,			false,		PARSE_S6,
							PARSE_BEGIN,	T_CONSTANT,		false,		PARSE_S7,
							PARSE_BEGIN,	T_PARA_O,		false,		PARSE_S8,
							PARSE_BEGIN,	T_END,			false,		PARSE_ACCEPT,

							PARSE_S1,		T_EQU,			false,		PARSE_S10,
							PARSE_S1,		T_END,			true,		RED_11,
							PARSE_S1,		T_MUL,			true,		RED_11,
							PARSE_S1,		T_MIN,			true,		RED_11,
							PARSE_S1,		T_DIV,			true,		RED_11,
							PARSE_S1,		T_ADD,			true,		RED_11,
							PARSE_S1,		T_PARA_C,		true,		RED_11,

							PARSE_S2,		T_END,			true,		RED_2,
							PARSE_S2,		T_ADD,			false,		PARSE_S11,
							PARSE_S2,		T_MIN,			false,		PARSE_S12,

							PARSE_S3,		T_END,			true,		RED_5,
							PARSE_S3,		T_ADD,			true,		RED_5,
							PARSE_S3,		T_MIN,			true,		RED_5,
							PARSE_S3,		T_MUL,			false,		PARSE_S13,
							PARSE_S3,		T_DIV,			false,		PARSE_S14,
							PARSE_S3,		T_PARA_C,		true,		RED_5,

							PARSE_S4,		T_END,			true,		RED_8,
							PARSE_S4,		T_ADD,			true,		RED_8,
							PARSE_S4,		T_MIN,			true,		RED_8,
							PARSE_S4,		T_MUL,			true,		RED_8,
							PARSE_S4,		T_DIV,			true,		RED_8,
							PARSE_S4,		T_PARA_C,		true,		RED_8,

							PARSE_S5,		T_IDENTIFIER,	false,		PARSE_S15,
							PARSE_S5,		T_CONSTANT,		false,		PARSE_S16,

							PARSE_S6,		T_CONSTANT,		false,		PARSE_S17,

							PARSE_S7,		T_END,			true,		RED_14,
							PARSE_S7,		T_ADD,			true,		RED_14,
							PARSE_S7,		T_MIN,			true,		RED_14,
							PARSE_S7,		T_MUL,			true,		RED_14,
							PARSE_S7,		T_DIV,			true,		RED_14,
							PARSE_S7,		T_PARA_C,		true,		RED_14,

							PARSE_S8,		'E',			false,		PARSE_S9,
							PARSE_S8,		'T',			false,		PARSE_S3,
							PARSE_S8,		'F',			false,		PARSE_S4,
							PARSE_S8,		T_MIN,			false,		PARSE_S5,
							PARSE_S8,		T_ADD,			false,		PARSE_S6,
							PARSE_S8,		T_CONSTANT,		false,		PARSE_S7,
							PARSE_S8,		T_PARA_O,		false,		PARSE_S8,
							PARSE_S8,		T_IDENTIFIER,	false,		PARSE_S1,

							PARSE_S9,		T_PARA_C,		false,		PARSE_S18,
							PARSE_S9,		T_ADD,			false,		PARSE_S11,
							PARSE_S9,		T_MIN,			false,		PARSE_S12,

							PARSE_S10,		'E',			false,		PARSE_S23,
							PARSE_S10,		'T',			false,		PARSE_S3,
							PARSE_S10,		'F',			false,		PARSE_S4,
							PARSE_S10,		T_MIN,			false,		PARSE_S5,
							PARSE_S10,		T_ADD,			false,		PARSE_S6,
							PARSE_S10,		T_CONSTANT,		false,		PARSE_S7,
							PARSE_S10,		T_PARA_O,		false,		PARSE_S8,
							PARSE_S10,		T_IDENTIFIER,	false,		PARSE_S1,

							PARSE_S11,		'T',			false,		PARSE_S19,
							PARSE_S11,		'F',			false,		PARSE_S4,
							PARSE_S11,		T_MIN,			false,		PARSE_S5,
							PARSE_S11,		T_ADD,			false,		PARSE_S6,
							PARSE_S11,		T_CONSTANT,		false,		PARSE_S7,
							PARSE_S11,		T_PARA_O,		false,		PARSE_S8,
							PARSE_S11,		T_IDENTIFIER,	false,		PARSE_S1,

							PARSE_S12,		'T',			false,		PARSE_S20,
							PARSE_S12,		'F',			false,		PARSE_S4,
							PARSE_S12,		T_MIN,			false,		PARSE_S5,
							PARSE_S12,		T_ADD,			false,		PARSE_S6,
							PARSE_S12,		T_CONSTANT,		false,		PARSE_S7,
							PARSE_S12,		T_PARA_O,		false,		PARSE_S8,
							PARSE_S12,		T_IDENTIFIER,	false,		PARSE_S1,

							PARSE_S13,		'F',			false,		PARSE_S21,
							PARSE_S13,		T_MIN,			false,		PARSE_S5,
							PARSE_S13,		T_ADD,			false,		PARSE_S6,
							PARSE_S13,		T_CONSTANT,		false,		PARSE_S7,
							PARSE_S13,		T_PARA_O,		false,		PARSE_S8,
							PARSE_S13,		T_IDENTIFIER,	false,		PARSE_S1,

							PARSE_S14,		'F',			false,		PARSE_S22,
							PARSE_S14,		T_MIN,			false,		PARSE_S5,
							PARSE_S14,		T_ADD,			false,		PARSE_S6,
							PARSE_S14,		T_CONSTANT,		false,		PARSE_S7,
							PARSE_S14,		T_PARA_O,		false,		PARSE_S8,
							PARSE_S14,		T_IDENTIFIER,	false,		PARSE_S1,

							PARSE_S15,		T_END,			true,		RED_10,
							PARSE_S15,		T_MUL,			true,		RED_10,
							PARSE_S15,		T_MIN,			true,		RED_10,
							PARSE_S15,		T_DIV,			true,		RED_10,
							PARSE_S15,		T_ADD,			true,		RED_10,
							PARSE_S15,		T_PARA_C,		true,		RED_10,

							PARSE_S16,		T_END,			true,		RED_12,
							PARSE_S16,		T_MUL,			true,		RED_12,
							PARSE_S16,		T_MIN,			true,		RED_12,
							PARSE_S16,		T_DIV,			true,		RED_12,
							PARSE_S16,		T_ADD,			true,		RED_12,
							PARSE_S16,		T_PARA_C,		true,		RED_12,

							PARSE_S17,		T_END,			true,		RED_13,
							PARSE_S17,		T_MUL,			true,		RED_13,
							PARSE_S17,		T_MIN,			true,		RED_13,
							PARSE_S17,		T_DIV,			true,		RED_13,
							PARSE_S17,		T_ADD,			true,		RED_13,
							PARSE_S17,		T_PARA_C,		true,		RED_13,

							PARSE_S18,		T_END,			true,		RED_9,
							PARSE_S18,		T_MUL,			true,		RED_9,
							PARSE_S18,		T_MIN,			true,		RED_9,
							PARSE_S18,		T_DIV,			true,		RED_9,
							PARSE_S18,		T_ADD,			true,		RED_9,
							PARSE_S18,		T_PARA_C,		true,		RED_9,

							PARSE_S19,		T_END,			true,		RED_3,
							PARSE_S19,		T_MIN,			true,		RED_3,
							PARSE_S19,		T_ADD,			true,		RED_3,
							PARSE_S19,		T_PARA_C,		true,		RED_3,
							PARSE_S19,		T_MUL,			false,		PARSE_S13,
							PARSE_S19,		T_DIV,			false,		PARSE_S14,

							PARSE_S20,		T_END,			true,		RED_4,
							PARSE_S20,		T_MIN,			true,		RED_4,
							PARSE_S20,		T_ADD,			true,		RED_4,
							PARSE_S20,		T_PARA_C,		true,		RED_4,
							PARSE_S20,		T_MUL,			false,		PARSE_S13,
							PARSE_S20,		T_DIV,			false,		PARSE_S14,

							PARSE_S21,		T_END,			true,		RED_6,
							PARSE_S21,		T_MIN,			true,		RED_6,
							PARSE_S21,		T_ADD,			true,		RED_6,
							PARSE_S21,		T_PARA_C,		true,		RED_6,
							PARSE_S21,		T_MUL,			true,		RED_6,
							PARSE_S21,		T_DIV,			true,		RED_6,

							PARSE_S22,		T_END,			true,		RED_7,
							PARSE_S22,		T_MIN,			true,		RED_7,
							PARSE_S22,		T_ADD,			true,		RED_7,
							PARSE_S22,		T_PARA_C,		true,		RED_7,
							PARSE_S22,		T_MUL,			true,		RED_7,
							PARSE_S22,		T_DIV,			true,		RED_7,

							PARSE_S23,		T_END,			true,		RED_1,
							PARSE_S23,		T_ADD,			false,		PARSE_S11,
							PARSE_S23,		T_MIN,			false,		PARSE_S12,


};
